"use strict";

exports.__esModule = true;
exports.default = LRUCache;

function LRUCache(size, multiArgs) {
  if (multiArgs === void 0) {
    multiArgs = false;
  }

  var cache = new Map();

  function getIterable(key) {
    var entryKey;

    for (var _iterator = cache.keys(), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var k = _ref;
      var x = void 0;
      var wasEqual = true;

      if (k.length !== key.length) {
        continue;
      }

      for (x = 0; x < k.length; x++) {
        if (key[x] !== k[x]) {
          wasEqual = false;
          break;
        }
      }

      if (wasEqual) {
        entryKey = k;
        break;
      }
    }

    return entryKey === void 0 ? void 0 : cache.get(entryKey);
  }

  var getter = multiArgs === true ? getIterable : cache.get.bind(cache);

  function get(key) {
    var item = getter(key); // found a cached entry

    if (item !== void 0) {
      // move it to the end of the cache
      cache.delete(key);
      cache.set(key, item); // delete the entry at the front of the cache

      if (cache.size > size) {
        var cacheIter = cache.keys();
        cache.delete(cacheIter.next().value);
      } // return the entry


      return item;
    } // console.log('Uncached:', key)
    // no entry found in cache, return undefined


    return void 0;
  }

  return {
    get: get,
    set: cache.set.bind(cache)
  };
}